diff -Naur dovecot-2.2.19/src/lib-ssl-iostream/iostream-openssl-context.c dovecot-2.2.19-patched/src/lib-ssl-iostream/iostream-openssl-context.c
--- dovecot-2.2.19/src/lib-ssl-iostream/iostream-openssl-context.c	2015-01-29 17:01:15.000000000 +0100
+++ dovecot-2.2.19-patched/src/lib-ssl-iostream/iostream-openssl-context.c	2015-12-02 15:45:54.513378462 +0100
@@ -30,11 +30,14 @@
 
 const char *openssl_iostream_error(void)
 {
-	unsigned long err;
+	unsigned long err = 0;
 	char *buf;
 	size_t err_size = 256;
 
-	err = ERR_get_error();
+	/* return only the most recent error in the queue */
+	while(ERR_peek_error() != 0) {
+                err = ERR_get_error();
+        }
 	if (err == 0) {
 		if (errno != 0)
 			return strerror(errno);
@@ -179,6 +182,11 @@
 	BIO *in;
 	X509 *x;
 	int ret = 0;
+	
+	/* make sure the OpenSSL error queue is empty when we begin */
+	while (ERR_peek_error() != 0) {
+                ERR_get_error();
+        }
 
 	in = BIO_new_mem_buf(t_strdup_noconst(cert), strlen(cert));
 	if (in == NULL)
